' SSP Demo.spin C. Eberspcher
' This demo shows the speed of compiled c to asm
' passing of variables with pointers
' Speed Factor is 5.5

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  LCD_PIN   = 9                                         ' for Parallax 4x20 serial LCD on P0
  LCD_BAUD  = 19_200
  LCD_LINES = 4



  
OBJ

        lcd : "debug_lcd"
        ssp : "SSP_SmallC"
Var

  long  Stack[20]             'Stack space for new cog
  long  sp                    ' Stack pointer of Small Small C
  long data

  long bufbas
  long S2CBas, C2SBas                   ' Pointer to Commonblock

  long a,b,count,loopc,oldcount
  
PUB main 

  data:= 5
  lcd.start(LCD_PIN, LCD_BAUD, LCD_LINES)            ' start lcd
  lcd.cursor(1)                                       ' cursor off
  lcd.backLight(true)                                 ' backlight on (if available)
  lcd.cls                                             ' clear the lcd
  lcd.str(string("SSP - Demo ", 13))

  sp:=-8+ssp.Start     ' Start C- Program

  cognew(Spinloop,@Stack)
  
  bufbas:= ssp.GTBUF
  S2CBas:= ssp.GtS2C
  C2SBas:= ssp.GtC2S

  long[bufbas][0]:=0

  'ShowBUF
  'ShoWCommon
  'ShowSP

  repeat
    lcd.gotoxy(10,1)               ' Display c
    lcd.decf(SSP.GtP_lcount,8)
    lcd.gotoxy(10,2)
    lcd.decf(SSP.GtP_a,8)
    lcd.gotoxy(10,3)
    lcd.decf(SSP.GtP_b,8)

    lcd.gotoxy(0,1)               ' Display spin
    lcd.decf(loopc,8)
    lcd.gotoxy(0,2)
    lcd.decf(a,8)  
    lcd.gotoxy(0,3)
    lcd.decf(b,8)
    waitcnt(cnt+40_000_000)   

PUB Spinloop                      ' Just a small Demo
  repeat
    a++
    b:=a*3
    outb:=a
     
    count:=cnt
    loopc:=count-oldcount
    oldcount:=count





  
PUB ShowSP
  repeat   
    lcd.gotoxy(13,0)
    'lcd.decf(sp,2)
    lcd.decf(ssp.GtP_a,6) 

    waitcnt(cnt+10_000_000)
    lcd.gotoxy(1,1)
    data:= long[sp][0]
    lcd.decf(data,8)
    'waitcnt(cnt+1_000_000)
     
    lcd.gotoxy(10,1)
    data:= long[sp][-10]
    lcd.decf(data,8)
    
    lcd.gotoxy(1,2)
    data:= long[sp][-9]
    lcd.decf(data,8) 

    lcd.gotoxy(10,2)
    data:= long[sp][-8]
    lcd.decf(data,8) 
    
    lcd.gotoxy(1,3)
    data:= long[sp][-7]
    lcd.decf(data,8) 

    lcd.gotoxy(10,3)
    data:= long[sp][-6]
    lcd.decf(data,8)
    'long[sp][1]++


PUB ShowBuf
  lcd.gotoxy(13,0)
  lcd.decf(bufbas,2) 
  repeat
    waitcnt(cnt+10_000_000)
    lcd.gotoxy(1,1)
    data:= long[bufbas][0]
    lcd.decf(data,8)
    'waitcnt(cnt+1_000_000)
     
    lcd.gotoxy(10,1)
    data:= long[bufbas][1]
    lcd.decf(data,8)
    
    lcd.gotoxy(1,2)
    data:= long[bufbas][2]
    lcd.decf(data,8) 

    lcd.gotoxy(10,2)
    data:= long[bufbas][3]
    lcd.decf(data,8) 
    
    lcd.gotoxy(1,3)
    data:= long[bufbas][4]
    lcd.decf(data,8) 

    lcd.gotoxy(10,3)
    data:= long[bufbas][5]
    lcd.decf(data,8)

    long[bufbas][0]++
    
 